import type Layer from "@arcgis/core/layers/Layer";
import type SceneLayer from "@arcgis/core/layers/SceneLayer";
import type PortalItem from "@arcgis/core/portal/PortalItem";
import type { RendererUnion } from "@arcgis/core/renderers/types.js";
import type { FeatureSettings } from "../data/FeatureSettings.js";
import type { QuerySourceCapabilities } from "../data/QuerySourceCapabilities.js";
import type { Schema } from "../data/Schema.js";
import type { SceneLayerJson } from "../json/SceneLayerJson.js";
import type { PropertyDefs } from "../support/Serializable.js";
import type { LayerExtensionProperties, LayerProperties } from "./_LayerExtension.js";
import { LayerExtension } from "./_LayerExtension.js";
/**
 * Properties that can be passed into the constructor for
 * {@link SceneLayerExtension}.
 */
export interface SceneLayerExtensionProperties extends LayerExtensionProperties {
    /**
     * The Esri SceneLayer object being extended.
     */
    layer?: SceneLayer | (SceneLayerJson & LayerProperties);
    /**
     * See {@link SceneLayerExtension.enableClientSideData}.
     */
    enableClientSideData?: boolean;
}
/**
 * Extends the capabilities of an Esri SceneLayer object.
 */
export declare class SceneLayerExtension extends LayerExtension<SceneLayerExtensionProperties> {
    get layer(): SceneLayer;
    /**
     * Indicates that the layer's data should be available client-side, within
     * the graphics that render on the map. Client-side data allows for fast
     * identify operations to be performed, as no external queries are
     * necessary; however, this can cause the map's load time to increase. When
     * enabled, all fields that are configured in the layer's PopupTemplate will
     * load client-side. The default is false.
     */
    get enableClientSideData(): boolean;
    set enableClientSideData(isEnabled: boolean);
    private _enableClientSideData;
    get renderer(): RendererUnion;
    get hasFeatures(): boolean;
    get canChangeLabels(): boolean;
    get canChangeRenderer(): boolean;
    get canChangeDefinitionExpression(): boolean;
    /**
     * @inheritDoc
     */
    protected _capabilities(): QuerySourceCapabilities;
    protected _onInitialize(): Promise<void>;
    protected _getSerializableProperties(): PropertyDefs<SceneLayerExtensionProperties>;
    /**
     * @inheritDoc
     */
    protected _isSupportedLayer(layer: Layer): boolean;
    protected _createSchema(): Schema;
    protected _createFeatureSettings(): FeatureSettings;
    protected _applyPortalItemProperties(portalItem: PortalItem): Promise<void>;
    private _updateClientSideFields;
}
